
#ifndef __EXTENSIONS_H__
#define __EXTENSIONS_H__

//#include <windows.h>
#ifndef OS_X
#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>
#include <GL/glxext.h>
#include <GL/glext.h>
#else
#include <SDL.h>
#include <gl.h>
#include <glu.h>
#include <glext.h>
#endif

#ifndef OS_X
extern PFNGLCREATEPROGRAMOBJECTARBPROC		glCreateProgramObjectARB;
extern PFNGLDELETEOBJECTARBPROC			glDeleteObjectARB;
extern PFNGLCREATESHADEROBJECTARBPROC		glCreateShaderObjectARB;
extern PFNGLSHADERSOURCEARBPROC			glShaderSourceARB;
extern PFNGLCOMPILESHADERARBPROC		glCompileShaderARB;
extern PFNGLGETOBJECTPARAMETERIVARBPROC		glGetObjectParameterivARB;
extern PFNGLATTACHOBJECTARBPROC			glAttachObjectARB;
extern PFNGLGETINFOLOGARBPROC			glGetInfoLogARB;
extern PFNGLLINKPROGRAMARBPROC			glLinkProgramARB;
extern PFNGLUSEPROGRAMOBJECTARBPROC		glUseProgramObjectARB;
extern PFNGLGETUNIFORMLOCATIONARBPROC		glGetUniformLocationARB;
extern PFNGLUNIFORM1FARBPROC			glUniform1fARB;
extern PFNGLUNIFORM1IARBPROC			glUniform1iARB;

/////////////////////////////////////////////////// ARB_vertex_program + ARB_fragment_program
#define GL_VERTEX_PROGRAM_ARB				0x8620
#define GL_FRAGMENT_PROGRAM_ARB				0x8804
#define GL_PROGRAM_FORMAT_ASCII_ARB			0x8875
#define GL_PROGRAM_ERROR_STRING_ARB			0x8874
#define GL_PROGRAM_ERROR_POSITION_ARB		0x864B

/*typedef void (APIENTRY *PFNGLPROGRAMSTRINGARB)(GLenum target, GLenum format, GLsizei len, const void *string);
typedef void (APIENTRY *PFNGLBINDPROGRAMARB)(GLenum target, GLuint program);
typedef void (APIENTRY *PFNGLDELETEPROGRAMSARB)(GLsizei n, const GLuint *programs);
typedef void (APIENTRY *PFNGLGENPROGRAMSARB)(GLsizei n, GLuint *programs);

typedef void (APIENTRY *PFNGLPROGRAMENVPARAMETER4DARB)(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
typedef void (APIENTRY *PFNGLPROGRAMENVPARAMETER4DVARB)(GLenum target, GLuint index, const GLdouble * params);
typedef void (APIENTRY *PFNGLPROGRAMENVPARAMETER4FARB)(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
typedef void (APIENTRY *PFNGLPROGRAMENVPARAMETER4FVARB)(GLenum target, GLuint index, const GLfloat * params);

typedef void (APIENTRY *PFNGLPROGRAMLOCALPARAMETER4DARB)(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
typedef void (APIENTRY *PFNGLPROGRAMLOCALPARAMETER4DVARB)(GLenum target, GLuint index, const GLdouble * params);
typedef void (APIENTRY *PFNGLPROGRAMLOCALPARAMETER4FARB)(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
typedef void (APIENTRY *PFNGLPROGRAMLOCALPARAMETER4FVARB)(GLenum target, GLuint index, const GLfloat * params);*/

extern PFNGLGENPROGRAMSARBPROC					glGenProgramsARB;
extern PFNGLPROGRAMSTRINGARBPROC				glProgramStringARB;
extern PFNGLBINDPROGRAMARBPROC					glBindProgramARB;
extern PFNGLDELETEPROGRAMSARBPROC				glDeleteProgramsARB;
extern PFNGLPROGRAMENVPARAMETER4FARBPROC			glProgramEnvParameter4fARB;
extern PFNGLPROGRAMENVPARAMETER4FVARBPROC			glProgramEnvParameter4fvARB;
extern PFNGLPROGRAMLOCALPARAMETER4FARBPROC			glProgramLocalParameter4fARB;
extern PFNGLPROGRAMLOCALPARAMETER4FVARBPROC			glProgramLocalParameter4fvARB;

/////////////////////////////////////////////////// ARB_vertex_buffer_object
#define GL_ARRAY_BUFFER_ARB					0x8892
#define GL_ELEMENT_ARRAY_BUFFER_ARB			0x8893
#define GL_STATIC_DRAW_ARB					0x88E4

/*typedef void (APIENTRY * PFNGLBINDBUFFERARB) (GLenum target, GLuint buffer);
typedef void (APIENTRY * PFNGLDELETEBUFFERSARB) (GLsizei n, const GLuint *buffers);
typedef void (APIENTRY * PFNGLGENBUFFERSARB) (GLsizei n, GLuint *buffers);
typedef void (APIENTRY * PFNGLBUFFERDATAARB) (GLenum target, int size, const GLvoid *data, GLenum usage);*/

extern PFNGLBINDBUFFERARBPROC					glBindBufferARB;
extern PFNGLDELETEBUFFERSARBPROC				glDeleteBuffersARB;
extern PFNGLGENBUFFERSARBPROC					glGenBuffersARB;
extern PFNGLBUFFERDATAARBPROC					glBufferDataARB;

/////////////////////////////////////////////////// vertex array
//typedef void (APIENTRY *PFNGLDRAWRANGEELEMENTS)(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices);

//extern PFNGLDRAWRANGEELEMENTSPROC				glDrawRangeElements;
#endif 

bool isExtensionSupported( const char *extension );
bool loadExtensions();

#endif
