
#include "ModPlayer.h"
//#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#ifndef FMOD
#include "fmod/minifmod.h"
#else
#include "fmod.h"
#endif
#include "../Data/music.h"		// xm

#ifndef FMOD
typedef struct 
{
	int length;
	int pos;
	void *data;
} MEMFILE;

unsigned int memopen(char *name)
{
	MEMFILE *memfile;

	memfile = new MEMFILE;
	memfile->length = sizeof( music );
	memfile->data = (void*)music;
	memfile->pos = 0;

	return reinterpret_cast<unsigned int>( memfile );
}

void memclose(unsigned int handle)
{
	MEMFILE *memfile = (MEMFILE*)handle;
	delete memfile;
}

int memread(void *buffer, int size, unsigned int handle)
{
	MEMFILE *memfile = (MEMFILE*)handle;

	if (memfile->pos + size >= memfile->length)
		size = memfile->length - memfile->pos;

	memcpy(buffer, (char *)memfile->data+memfile->pos, size);
	memfile->pos += size;
	
	return size;
}

void memseek(unsigned int handle, int pos, signed char mode)
{
	MEMFILE *memfile = (MEMFILE*)handle;

	if (mode == SEEK_SET) 
		memfile->pos = pos;
	else if (mode == SEEK_CUR) 
		memfile->pos += pos;
	else if (mode == SEEK_END)
		memfile->pos = memfile->length + pos;

	if (memfile->pos > memfile->length)
		memfile->pos = memfile->length;
}

int memtell(unsigned int handle)
{
	MEMFILE *memfile = (MEMFILE*)handle;
	return memfile->pos;
}
#endif

ModPlayer::ModPlayer() {
#ifndef FMOD
	FSOUND_File_SetCallbacks( memopen, memclose, memread, memseek, memtell );
	FSOUND_Init(44100, 0);
	mod = FMUSIC_LoadSong( 0, 0 );
#else
	fsound = 0;
	FMOD_System_Create(&system);
	FMOD_System_Init(system, 1, FMOD_INIT_NORMAL, NULL);
	FMOD_System_CreateSound(system, "music.xm", FMOD_SOFTWARE | FMOD_CREATESTREAM, 0, &fsound);
#endif
}

ModPlayer::~ModPlayer() {
	//FMUSIC_FreeSong( mod );
}

void ModPlayer::play() {
#ifndef FMOD
	FMUSIC_PlaySong( mod );
#else
	FMOD_System_PlaySound(system, FMOD_CHANNEL_FREE, fsound, 0, &channel);
#endif
}

void ModPlayer::stop() {
#ifndef FMOD
	FMUSIC_FreeSong( mod );
#else
	FMOD_Sound_Release(fsound);
	FMOD_System_Close(system);
	FMOD_System_Release(system);
#endif
} 
